%=======================================================================
%To solve optimization problem:
%Create a new subfolder in ...\PSG\MATLAB:
%..\PSG\MATLAB\problem_2_Korea_retail_bound_0_2_long
%Download and unpack the following zipped file from 'Data' to the created folder:
%'Mat_data_problem_2_Korea_retail_bound_0_2_long.zip'
%Run program 'problem_2_Korea_retail_bound_0_2_long.m'
%=======================================================================

clc;
clear;
addpath('..');

%Load data:
load('.\problem_2_Korea_retail_bound_0_2_long_data.mat')
%Define options for PSG solver:
stroptions.Solver = 'TANK';
stroptions.Precision = 9;
stroptions.Stages = 30;
%Define input arguments:
string = {'var_dev'};
w = {0.9984};

%Solve optimization problems:
[xout, fval, status, output] = riskprog(string, w, H, [], p, [], A, b, [], [], lb, ub, [], stroptions);
 
%Display results:
disp(' ');
disp('Results: ');
%Display status of optimization problem:
disp(sprintf('status of optimization problem = %s', status));
%Display solving time:
disp(sprintf('solving time = %g', output.solving_time));
%Display objective:
disp(sprintf('objective = %g', fval));
%Display function:
disp(sprintf('var_dev= %g', output.frval));
%Display left hand sides of linear inequality:
disp(sprintf('linear inequality = %g', output.fAval));
%Display residual of linear inequality:
disp(sprintf('residual of linear inequality = %g', output.rAval));
%Display optimal point:
disp('optimal point = ');
disp(xout');
